package com.hexace.editor.services
{
    import com.hexace.editor.model.vo.customer.Customer;
    import com.hexace.editor.model.vo.functionality.Functionality;
    import com.hexace.editor.model.vo.module.Module;
//edited class name !!
    public class ConfigParsers implements IConfigParser
    {
        private var _data:XML;

        public function set data(v:XML):void
        {
            //trace("ConfigParser.data(v) "+v);

            _data=v;
        }

        public function parseCustomer():Customer
        {
            trace("ConfigParser.parseCustomer()");

            var customer:Customer=new Customer(_data.customer.@name, _data.customer.databaseName, _data.customer.databaseUser, _data.customer.databasePass, _data.customer.id);

            return customer;
        }

        public function parseModules(customerId:uint):Vector.<Module>
        {
            trace("ConfigParser.parseModules(customerId)");

            var modules:Vector.<Module>=new Vector.<Module>();

            for each (var item:XML in _data.customer.module)
            {
                var module:Module=new Module(item.@name, item.@type, item.@id, item.@customerId);
                modules.push(module);
            }
            trace("--modules " + modules[0].id);
            return modules;
        }

        public function parseFunctionalitiesForModule(moduleId:uint):Vector.<Functionality>
        {
            trace("ConfigParser.parseFunctionalitiesForModule(moduleId)");

            var functionalities:Vector.<Functionality>=new Vector.<Functionality>;

            for each (var item:XML in _data.customer.module.(@id == moduleId).functionality)
            {
                var functionality:Functionality=new Functionality(item.@type, item.@moduleId, item.@id);
                functionalities.push(functionality);
            }

            return functionalities;
        }
    }
}
