package com.hexace.editor.view
{
	import com.hexace.editor.events.CustomerEvent;
	import com.hexace.editor.model.CustomerModel;
	
	import flash.events.Event;
	
	import org.robotlegs.mvcs.Mediator;
	
	public class CustomerFormMediator extends Mediator
	{
		[Inject]
		public var customerModel:CustomerModel;
		
		[Inject]
		public var view:CustomerFormView;
		
		//[Inject]
		//public var customerService:ConfigService;//not used, and actually shouldn't be here anyway
		
		override public function onRegister():void
		{
			trace("[Mediator]---CustomerPanelViewMediator.onRegister()");
			
			//view.enabled = false;
			
			addViewListener(CustomerEvent.UPDATE_CUSTOMER, updateCustomer);
			addViewListener(CustomerEvent.SAVE_CUSTOMER, dispatch);
			addContextListener(CustomerEvent.CUSTOMER_LOADED, onCustomerLoaded);
			addContextListener(CustomerEvent.CUSTOMER_UPDATED, onCustomerUpdated);
			
			//moved to HexaceEditorContext.onApplicationComplete :
			
			/*var loadCustomerEvent:CustomerEvent = new CustomerEvent(CustomerEvent.LOAD, null);
			loadCustomerEvent.path = "config_2_0.xml";//better from a vo 
			dispatch(loadCustomerEvent);*/
		}
		
		private function onCustomerLoaded(e:CustomerEvent):void
		{
			trace("[Mediator]---CustomerPanelViewMediator.onCustomerLoaded(e)");			
			//view.enabled = true;
			view.customer = e.customer;
		}
		
		private function updateCustomer(e:CustomerEvent):void
		{
			trace("[Mediator]---CustomerPanelViewMediator.updateCustomer(e) ");
			//here you can dispatch an event triggering an UpdateCustommerCommand-> CustomerModel.updateCustomer
			customerModel.customer = e.customer;
		}
		
		private function onCustomerUpdated(e:CustomerEvent):void
		{
			trace("[Mediator]---CustomerPanelViewMediator.onCustomerUpdated(e)");			
			view.customer = e.customer;
		}
	}
}