package com.hexace.editor.view
{
    import com.hexace.editor.events.ModuleEvent;
    //import com.hexace.editor.model.vo.module.Module;
    import org.robotlegs.mvcs.Mediator;

    public class ModuleFormMediator extends Mediator
    {
        [Inject]
        public var view:ModuleFormView;

        override public function onRegister():void
        {
            trace("[Mediator]---ModuleFormMediator.onRegister() ");
            addViewListener(ModuleEvent.ADD_MODULE, dispatch);
            addViewListener(ModuleEvent.UPDATE_MODULE, dispatch);
            addViewListener(ModuleEvent.DELETE_MODULE, dispatch);

            addContextListener(ModuleEvent.MODULE_ADDED, onModuleAdded);
            addContextListener(ModuleEvent.MODULE_UPDATED, onModuleUpdated);
            addContextListener(ModuleEvent.MODULE_DELETED, onModuleDeleted);
            addContextListener(ModuleEvent.MODULE_SELECTED, onModuleSelected);
        }

        private function onModuleAdded(event:ModuleEvent):void
        {
            trace("ModuleFormMediator.onModuleAdded(event)");
			view.module=event.module;
        }

        private function onModuleUpdated(event:ModuleEvent):void
        {
            trace("ModuleFormMediator.onModuleUpdated(event)");
			view.module=event.module;
        }

        private function onModuleDeleted(event:ModuleEvent):void
        {
            view.onModuleDeleted();
            trace("ModuleFormMediator.onModuleDeleted(event)");
        }

        private function onModuleSelected(event:ModuleEvent):void
        {
            view.module=event.module;
            trace("ModuleFormMediator.onModuleSelected(event)");
        }
    }
}
